import { DynamoDBClient, DynamoDBClientConfig } from '@aws-sdk/client-dynamodb';
import { DbItem, DbPlugin, DbPluginConfig, HandleRequest, Jovo, PersistableSessionData, PersistableUserData } from '@jovotech/framework';
export interface DynamoDbConfig extends DbPluginConfig {
    table: {
        name: string;
        createTableOnInit?: boolean;
        primaryKeyColumn?: string;
        readCapacityUnits?: number;
        writeCapacityUnits?: number;
    };
    libraryConfig?: {
        dynamoDbClient?: DynamoDBClientConfig;
    };
}
export interface DynamoDbItem {
    id: string;
    user?: PersistableUserData;
    session?: PersistableSessionData;
    createdAt?: string;
    updatedAt?: string;
}
export declare class DynamoDb extends DbPlugin<DynamoDbConfig> {
    client: DynamoDBClient;
    getDefaultConfig(): DynamoDbConfig;
    constructor(config: DynamoDbConfig);
    mount(parent: HandleRequest): Promise<void> | void;
    initialize(): Promise<void>;
    createTable(): Promise<void>;
    getDbItem(primaryKey: string): Promise<DbItem>;
    loadData(userId: string, jovo: Jovo): Promise<void>;
    saveData(userId: string, jovo: Jovo): Promise<void>;
    checkRequirements(): void | Error;
}
